%define major 8
%define libname %mklibname jpeg %{major}
%define lib6name %mklibname jpeg 62
%define turbomajor 0
%define libturbo %mklibname turbojpeg %{turbomajor}
%define develname %mklibname -d jpeg
%define staticname %mklibname -s -d jpeg

Summary:	A MMX/SSE2 accelerated library for manipulating JPEG image files
Name:		libjpeg
Epoch:		1
Version:	1.5.1
%define subrel 3
Release:	%mkrel 1
License:	wxWidgets
Group:		System/Libraries
URL:		http://sourceforge.net/projects/libjpeg-turbo
Source0:	http://downloads.sourceforge.net/libjpeg-turbo/libjpeg-turbo-%{version}.tar.gz
# These two allow automatic lossless rotation of JPEG images from a digital
# camera which have orientation markings in the EXIF data. After rotation
# the orientation markings are reset to avoid duplicate rotation when
# applying these programs again.
Source2:	http://jpegclub.org/jpegexiforient.c
Source3:	http://jpegclub.org/exifautotran.txt
Patch0:		libjpeg-turbo-1.5.2-CVE-2017-15232.patch
Patch1:		libjpeg-turbo-1.5.3-CVE-2018-1152.patch
Patch2:		libjpeg-turbo-1.5.3-CVE-2018-11813.patch
Patch3:		libjpeg-turbo-1.5.1-CVE-2018-14498.patch
BuildRequires:	nasm

%description
The libjpeg package contains a shared library of functions for loading,
manipulating and saving JPEG format image files.

Install the libjpeg package if you need to manipulate JPEG files. You
should also install the jpeg-progs package.

%package -n	%{libname}
Summary:	A MMX/SSE2 accelerated library for manipulating JPEG image files
Group:		System/Libraries
Provides:	%{name} = %{epoch}:%{version}-%{release}

%description -n %{libname}
This package contains the library needed to run programs dynamically
linked with libjpeg-turbo.

%package -n     %{lib6name}
Summary:	A MMX/SSE2 accelerated library for manipulating JPEG image files
Group:		System/Libraries

%description -n %{lib6name}
This package contains the library needed to run programs dynamically
linked with libjpeg-turbo.

%package -n	%{libturbo}
Summary:	A MMX/SSE2 accelerated library for manipulating JPEG image files
Group:		System/Libraries
Obsoletes:	%{_lib}turbojpeg < 1:1.3.0
Conflicts:	%{_lib}jpeg-devel < 1:1.2.1-2

%description -n %{libturbo}
This package contains the library needed to run programs dynamically
linked with libjpeg-turbo.

%package -n	%{develname}
Summary:	Development tools for programs which will use the libjpeg library
Group:		Development/C
Requires:	%{libname} = %{epoch}:%{version}
Requires:	%{libturbo} = %{epoch}:%{version}
Provides:	jpeg-devel = %{epoch}:%{version}-%{release}
Provides:	jpeg%{major}-devel = %{epoch}:%{version}-%{release}
Provides:	%{name}-devel = %{epoch}:%{version}-%{release}
Provides:	libjpeg-turbo-devel
Obsoletes:	%{name}-devel < %{epoch}:%{version}-%{release}
Conflicts:	jpeg6-devel
Conflicts:	%{_lib}turbojpeg < 1:1.3.0
Obsoletes:	%{mklibname jpeg 62 -d} < 6b-45

%description -n	%{develname}
The libjpeg-devel package includes the header files necessary for 
developing programs which will manipulate JPEG files using
the libjpeg library.

If you are going to develop programs which will manipulate JPEG images,
you should install libjpeg-devel.  You'll also need to have the libjpeg
package installed.

%package -n	%{staticname}
Summary:	Static libraries for programs which will use the libjpeg library
Group:		Development/C
Requires:	%{develname} = %{epoch}:%{version}-%{release}
Provides:	%{name}-static-devel = %{epoch}:%{version}-%{release}
Provides:	jpeg-static-devel = %{epoch}:%{version}-%{release}
Provides:	jpeg%{major}-static-devel = %{epoch}:%{version}-%{release}
Conflicts:	jpeg6-static-devel
Obsoletes:	%{mklibname jpeg 62 -d -s} < 6b-45
Obsoletes:	%{mklibname jpeg 7 -d -s} < 7-3

%description -n	%{staticname}
The libjpeg-devel package includes the static librariesnecessary for 
developing programs which will manipulate JPEG files using
the libjpeg library.

If you are going to develop programs which will manipulate JPEG images,
you should install libjpeg-devel.  You'll also need to have the libjpeg
package installed.

%package -n	jpeg-progs
Summary:	Programs for manipulating JPEG format image files
Group:		Graphics/Utilities
Requires:	%{libname} = %{epoch}:%{version}-%{release}
Provides:	jpeg-progs = %{epoch}:%{version}-%{release}
Provides:	libjpeg-progs = %{epoch}:%{version}-%{release}

%description -n	jpeg-progs
The jpeg-progs package contains simple client programs for accessing 
the libjpeg functions.  Libjpeg client programs include cjpeg, djpeg, 
jpegtran, rdjpgcom and wrjpgcom.  Cjpeg compresses an image file into JPEG
format. Djpeg decompresses a JPEG file into a regular image file.  Jpegtran
can perform various useful transformations on JPEG files.  Rdjpgcom displays
any text comments included in a JPEG file.  Wrjpgcom inserts text
comments into a JPEG file.

%prep
%setup -qn libjpeg-turbo-%{version}
%autopatch -p1

%build
export CONFIGURE_TOP=`pwd`
mkdir 8
pushd 8
%configure2_5x \
    --with-jpeg8 \
    --disable-silent-rules \
    --enable-shared \
    --enable-static
%make_build
gcc %{optflags} -o jpegexiforient %{SOURCE2}
popd

mkdir 6
pushd 6
%configure2_5x \
    --enable-shared
%make_build
popd

%check
pushd 8
LD_PRELOAD=$PWD/.libs/%{name}.so make test
popd

%install
%make_install -C 8

rm -fr %{buildroot}%{_libdir}/*.la %{buildroot}%{_datadir}/doc

install -m 755 8/jpegexiforient %{buildroot}%{_bindir}
install -m 755 %{SOURCE3} %{buildroot}%{_bindir}
cp -fP 6/.libs/libjpeg.so.* %{buildroot}%{_libdir}

%files -n %{libname}
%doc coderules.txt jconfig.txt libjpeg.txt structure.txt usage.txt wizard.txt
%{_libdir}/libjpeg.so.%{major}{,.*}

%files -n %{lib6name}
%{_libdir}/libjpeg.so.62
%{_libdir}/libjpeg.so.62.*

%files -n %{libturbo}
%{_libdir}/libturbojpeg.so.%{turbomajor}
%{_libdir}/libturbojpeg.so.%{turbomajor}.*

%files -n %{develname}
%doc example.c
%{_libdir}/libjpeg.so
%{_libdir}/libturbojpeg.so
%{_libdir}/pkgconfig/libjpeg.pc
%{_libdir}/pkgconfig/libturbojpeg.pc
%{_includedir}/*.h

%files -n %{staticname}
%{_libdir}/*.a

%files -n jpeg-progs
%{_bindir}/*
%{_mandir}/man1/*


%changelog
* Tue Mar 26 2019 ns80 <ns80> 1:1.5.1-1.3.mga6
+ Revision: 1380350
- backport upstream patch for CVE-2018-14498 (mga#24565)
- add upstream patch for CVE-2017-15232 (mga#21974)
+ mrambo3501 <mrambo3501>
- add modified upstream patches which fix CVE-2018-1152 and CVE-2018-11813 (mga#23238)

* Wed Sep 21 2016 tv <tv> 1:1.5.1-1.mga6
+ Revision: 1054859
- new release

* Wed Sep 21 2016 tv <tv> 1:1.5.0-2.mga6
+ Revision: 1054831
- provides libjpeg-turbo-devel

* Tue Sep 20 2016 tv <tv> 1:1.5.0-1.mga6
+ Revision: 1054676
- new release
- adjust file list

* Fri Jun 10 2016 luigiwalser <luigiwalser> 1:1.4.2-2.mga6
+ Revision: 1021018
- add upstream patches to fix security issues found by Mozilla

* Wed Jun 08 2016 tv <tv> 1:1.4.2-1.mga6
+ Revision: 1020883
- new release

* Mon Feb 15 2016 umeabot <umeabot> 1:1.4.1-2.mga6
+ Revision: 961051
- Mageia 6 Mass Rebuild

* Wed Aug 12 2015 fwang <fwang> 1:1.4.1-1.mga6
+ Revision: 863403
- 1.4.1

* Mon Dec 15 2014 luigiwalser <luigiwalser> 1:1.3.1-4.mga5
+ Revision: 803252
- add patch from opensuse to fix CVE-2014-9092

* Wed Oct 15 2014 umeabot <umeabot> 1:1.3.1-3.mga5
+ Revision: 748384
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 1:1.3.1-2.mga5
+ Revision: 681547
- Mageia 5 Mass Rebuild

* Wed Jul 23 2014 fwang <fwang> 1:1.3.1-1.mga5
+ Revision: 655868
- 1.3.1

* Tue Nov 12 2013 luigiwalser <luigiwalser> 1:1.3.0-3.mga4
+ Revision: 550821
- add patch from google to fix CVE-2013-6629 and CVE-2013-6630

* Sat Oct 19 2013 umeabot <umeabot> 1:1.3.0-2.mga4
+ Revision: 524145
- Mageia 4 Mass Rebuild

* Wed May 29 2013 fwang <fwang> 1:1.3.0-1.mga4
+ Revision: 430376
- update file list
- update file list
- update file list
- new version 1.3.0

* Sat Jan 12 2013 umeabot <umeabot> 1:1.2.1-4.mga3
+ Revision: 357540
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild
+ boklm <boklm>
- Update group: Graphics/Other -> Graphics/Utilities

* Fri Nov 30 2012 ovitters <ovitters> 1:1.2.1-3.mga3
+ Revision: 323386
- clean spec
- update rpm group

* Tue Jul 10 2012 fwang <fwang> 1:1.2.1-2.mga3
+ Revision: 269180
- split libturbo

* Tue Jul 10 2012 fwang <fwang> 1:1.2.1-1.mga3
+ Revision: 269175
- new version 1.2.1
+ mitya <mitya>
- Revert Provides: on libjpeg62
- Fix Provides: for libjpeg62

* Mon Apr 23 2012 mitya <mitya> 1:1.2.0-4.mga2
+ Revision: 233122
- Provide libjpeg62 for all architectures

* Sat Feb 18 2012 zezinho <zezinho> 1:1.2.0-3.mga2
+ Revision: 210374
+ rebuild (emptylog)

* Sun Feb 12 2012 fwang <fwang> 1:1.2.0-2.mga2
+ Revision: 207971
- produce jpeg 6 also

* Sun Feb 12 2012 fwang <fwang> 1:1.2.0-1.mga2
+ Revision: 207937
- new version 1.2.0

* Sat Oct 29 2011 fwang <fwang> 1:1.1.90-1.mga2
+ Revision: 159559
- new version 1.1.90 (aka 1.2 beta1)

* Fri Sep 02 2011 fwang <fwang> 1:1.1.1-1.mga2
+ Revision: 138028
- switched to libjpeg-turbo flavour, syched with fedora

* Wed Mar 09 2011 dmorgan <dmorgan> 8b-5.mga1
+ Revision: 67225
- Bump release to allow to submit
+ eandry <eandry>
- resubmit, obsoleted by mistake

* Sat Jan 08 2011 blino <blino> 8b-2.mga1
+ Revision: 912
- remove old ldconfig scriptlet
- imported package libjpeg


* Mon Jul 12 2010 Oden Eriksson <oeriksson@mandriva.com> 8b-1mdv2011.0
+ Revision: 551250
- v8b

* Fri Apr 02 2010 Oden Eriksson <oeriksson@mandriva.com> 8a-1mdv2010.1
+ Revision: 530761
- 8a

* Tue Mar 02 2010 Oden Eriksson <oeriksson@mandriva.com> 8-6mdv2010.1
+ Revision: 513525
- droppatch.v8 (attempt to fix #57950)
- remove P1 as ?\195?\173t was added upstream

* Fri Feb 26 2010 Oden Eriksson <oeriksson@mandriva.com> 8-5mdv2010.1
+ Revision: 512122
- revert the last change
- bump release
- revert the temporary workaround

* Fri Feb 26 2010 Oden Eriksson <oeriksson@mandriva.com> 8-2mdv2010.1
+ Revision: 511910
- temporary have it provide libjpeg7

* Sun Jan 10 2010 Oden Eriksson <oeriksson@mandriva.com> 8-1mdv2010.1
+ Revision: 488683
- v8

* Mon Sep 07 2009 Oden Eriksson <oeriksson@mandriva.com> 7-5mdv2010.0
+ Revision: 432437
- fix #53474 (Manpages for jpeg-tools are not found)

* Fri Aug 21 2009 Funda Wang <fwang@mandriva.org> 7-4mdv2010.0
+ Revision: 418808
- do not obsoletes it self

* Thu Aug 20 2009 Anssi Hannula <anssi@mandriva.org> 7-3mdv2010.0
+ Revision: 418607
- remove major from devel package names as per policy
- adapt conflicts with jpeg6-devel for biarch
- obsolete the old devel packages, so that upgrading users automatically
  get this version, while still allowing them to install libjpeg62-devel
  from contrib by explicitely requesting it

* Sat Aug 15 2009 Oden Eriksson <oeriksson@mandriva.com> 7-1mdv2010.0
+ Revision: 416493
- 7
- nuked some redundant patches
- rediffed some patches
- fix deps
- fix build (P1)

* Thu Dec 18 2008 Oden Eriksson <oeriksson@mandriva.com> 6b-44mdv2009.1
+ Revision: 315574
- rebuild

* Tue Jun 17 2008 Thierry Vignaud <tv@mandriva.org> 6b-43mdv2009.0
+ Revision: 222898
- rebuild

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Sun Jan 13 2008 Thierry Vignaud <tv@mandriva.org> 6b-42mdv2008.1
+ Revision: 150699
- rebuild
- kill re-definition of %%buildroot on Pixel's request

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot


* Mon Dec 11 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 6b-41mdv2007.0
+ Revision: 95114
- Add guards for C++ code (e.g. OpenVRML)

  + Oden Eriksson <oeriksson@mandriva.com>
    - bzip2 cleanup
    - rebuild
    - bunzip patches and sources
    - Import libjpeg

* Wed Jan 11 2006 Christiaan Welvaart <cjw@daneel.dyndns.org> 6b-39mdk
- add BuildRequires: libtool

* Sun Jan 01 2006 Mandriva Linux Team <http://www.mandrivaexpert.com/> 6b-38mdk
- Rebuild

* Thu Jul 21 2005 Nicolas Lécureuil <neoclust@mandriva.org> 6b-37mdk
- Fix error pointed out by Per Øyvind Karlsen and couriousous

* Thu Jul 21 2005 Nicolas Lécureuil <neoclust@mandriva.org> 6b-36mdk
- Clean My mess

* Thu Jul 21 2005 Nicolas Lécureuil <neoclust@mandriva.org> 6b-35mdk
- Provide jpegint.h because it is needed softwares

* Fri Feb 18 2005 Rafael Garcia-Suarez <rgarciasuarez@mandrakesoft.com> 6b-34mdk
- Rename 'libjpeg-progs' to 'jpeg-progs'

* Tue Dec 16 2003 Till Kamppeter <till@mandrakesoft.com> 6b-33mdk
- Updated patch for lossless cropping and pasting to the newest version,
  it contains also the EXIF fixes shown on 
  http://jpegclub.org/exifpatch.html
- Added orientation utilities from http://jpegclub.org/exif_orientation.html

